<template>
  <section class="panel border shadow">
    <h3>Goal</h3>
    <p>
      Be the first player to reach the top in <strong>3</strong> columns to win!
    </p>

    <h3>On your turn</h3>
    <p>
      Group your dice into two pairs by selecting two dice. Your selected dice
      form one pair, and the unselected dice form another.
    </p>
    <p>
      For each pair, a <em>climber</em> (<span class="climber">
        <img :src="whiteRingSrc" alt="white ring" /></span
      >) is added to the bottom of the column matching the pair's sum. Or if
      there already is a climber in the column, the climber climbs one level.
    </p>
    <p>
      <em>You can only climb <strong>3</strong> columns at a time!</em>
      When you have placed climbers in 3 columns, you must roll pairs matching
      those columns in order to keep climbing.
    </p>
    <p>
      If your paired dice do not successfully add or advance any of your
      climbers, your climbers are removed from the board and you lose all
      <em>unsaved progress</em>.
    </p>

    <h4>Saving progress</h4>
    <p>
      After moving climbers you can choose to stop, or to keep going. If you
      stop, a marker will be placed at your climber's location indicating your
      current progress. The next time you advance climbers in those columns they
      will continue from your marker, rather than starting from the bottom.
    </p>

    <h3>Reaching the top</h3>
    <p>
      Once a player's climber reaches the top level of a column, the player
      <em>wins</em> that column, and the column's value may no longer be used to
      place or advance climbers. However, the player may lose the column again
      unless they stop and save their progress.
    </p>
    <p>The first player to win 3 columns wins the game!</p>
  </section>
</template>

<script lang="ts">
import { defineComponent, PropType } from "vue";
import whiteRingSrc from "../assets/white-ring.svg";

export default defineComponent({
  name: "settings",
  data(vm) {
    return {
      settings: vm.initialSettings,
      whiteRingSrc,
    };
  },
  props: {
    initialSettings: { type: Object as PropType<GameSettings> },
  },
});
</script>

<style scoped lang="scss">
section {
  height: 100%;
  font-size: 85%;
  background-color: linen;
  overflow-y: auto;
}

h3,
h4 {
  font-weight: 500;

  margin-top: 1em;
  margin-bottom: 0.25em;
}

p {
  margin-top: 0;
  margin-bottom: 0.5em;
}

section > :first-child {
  margin-top: 0;
}
section > :last-child {
  margin-bottom: 0;
}

.climber {
  position: relative;
  height: 1em;
  width: 1em;
  display: inline-block;
  filter: drop-shadow(0 0 1px #000a);
  margin: 0 0.25em;
}
.climber > img {
  position: absolute;

  height: 100%;
  width: 100%;

  top: 50%;
  left: 50%;

  transform: translate(-50%, -50%) scale(125%) translateY(0.1em);
}
</style>
